//--------------------------------------------------------
//  Forex Expert Advisor Generator version 2.03 EA
//--------------------------------------------------------

#property copyright "Copyright  2010, Forex EA Generator v2.03"
#property link      "http://www.forexgenerator.com/"
#include <stdlib.mqh>

// exported variables
extern double BuyLots17 = 0.1;
extern int BuyStoploss17 = 15;
extern int BuyTakeprofit17 = 20;
extern double SellLots18 = 0.1;
extern int SellStoploss18 = 15;
extern int SellTakeprofit18 = 20;
extern int TrailingStop28 = 10;
extern int NewTakeProfit28 = 30;


// local variables
double PipValue=1;    // this variable is here to support 5-digit brokers
bool Terminated = false;
int Count26 = 0;


int init()
{
    
    Comment("");    // clear the chart
}

// Expert start
int start()
{
    if (Bars < 10)
    {
        Comment("Not enough bars");
        return (0);
    }
    if (Terminated == true)
    {
        Comment("EA Terminated.");
        return (0);
    }
    
    OnEveryTick16();
    
}

void OnEveryTick16()
{
    if (true) PipValue = 10;
    PrintInfoToChart26();
    TechnicalAnalysis2x25();
    TechnicalAnalysis2x24();
    TrailingStop28();
    
}

void PrintInfoToChart26()
{
    string temp = "Some Text\nExecuted : " + Count26 + "\n"
    + "Spread: " + DoubleToStr(MarketInfo(Symbol(), MODE_SPREAD)/PipValue, 2)+ "\n"
    + "------------------------------------------------\n"
    + "ACCOUNT INFORMATION:\n"
    + "\n"
    + "Account Name:     " + AccountName()+ "\n"
    + "Account Leverage:     " + DoubleToStr(AccountLeverage(), 0)+ "\n"
    + "Account Balance:     " + DoubleToStr(AccountBalance(), 2)+ "\n"
    + "Account Equity:     " + DoubleToStr(AccountEquity(), 2)+ "\n"
    + "Free Margin:     " + DoubleToStr(AccountFreeMargin(), 2)+ "\n"
    + "Used Margin:     " + DoubleToStr(AccountMargin(), 2)+ "\n"
    + "------------------------------------------------\n";
    Comment(temp);
    Count26++;
    
}

void TechnicalAnalysis2x25()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,1,1) == 4) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,3,1) == 3))
    {
        TechnicalAnalysis2x22();
        
    }
}

void TechnicalAnalysis2x22()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,5,1) == 2) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,7,1) == 1))
    {
        CloseOrder19();
        
    }
}

void CloseOrder19()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_SELL || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    IfOrderDoesNotExist21();
    
}

void IfOrderDoesNotExist21()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_BUY && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        BuyOrder17();
        
    }
}

void BuyOrder17()
{
    
    int ticket = OrderSend(Symbol(), OP_BUY, BuyLots17, Ask, 4, 0, 0, "My Buy", 1, 0, Blue);
    if (ticket > -1)
    {
        OrderSelect(ticket, SELECT_BY_TICKET);
        bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), Ask - BuyStoploss17*PipValue*Point, Ask + BuyTakeprofit17*PipValue*Point, 0, Blue);
        if (ret == false)
        Print("OrderModify() error - ", ErrorDescription(GetLastError()));
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TechnicalAnalysis2x24()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,0,1) == 4) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,2,1) == 3))
    {
        TechnicalAnalysis2x23();
        
    }
}

void TechnicalAnalysis2x23()
{
    if ((iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,4,1) == 2) && (iCustom(NULL, NULL, "ForexFreedomBars",1,5,15,30,30,2,2,2,2,6,1) == 1))
    {
        CloseOrder29();
        
    }
}

void CloseOrder29()
{
    int orderstotal = OrdersTotal();
    int orders = 0;
    int ordticket[30][2];
    for (int i = 0; i < orderstotal; i++)
    {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderType() != OP_BUY || OrderSymbol() != Symbol() || OrderMagicNumber() != 1)
        {
            continue;
        }
        ordticket[orders][0] = OrderOpenTime();
        ordticket[orders][1] = OrderTicket();
        orders++;
    }
    if (orders > 1)
    {
        ArrayResize(ordticket,orders);
        ArraySort(ordticket);
    }
    for (i = 0; i < orders; i++)
    {
        if (OrderSelect(ordticket[i][1], SELECT_BY_TICKET) == true)
        {
            bool ret = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 4, Red);
            if (ret == false)
            Print("OrderClose() error - ", ErrorDescription(GetLastError()));
        }
    }
    IfOrderDoesNotExist20();
    
}

void IfOrderDoesNotExist20()
{
    bool exists = false;
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderType() == OP_SELL && OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            exists = true;
        }
    }
    else
    {
        Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    }
    
    if (exists == false)
    {
        SellOrder18();
        
    }
}

void SellOrder18()
{
    
    int ticket = OrderSend(Symbol(), OP_SELL, SellLots18, Bid, 4, 0, 0, "My Sell", 1, 0, Red);
    if (ticket > -1)
    {
        OrderSelect(ticket, SELECT_BY_TICKET);
        bool ret = OrderModify(OrderTicket(), OrderOpenPrice(), Bid + SellStoploss18*PipValue*Point, Bid - SellTakeprofit18*PipValue*Point, 0, Red);
        if (ret == false)
        Print("OrderModify() error - ", ErrorDescription(GetLastError()));
            
    }
    else
    {
        Print("OrderSend() error - ", ErrorDescription(GetLastError()));
    }
}

void TrailingStop28()
{
    for (int i=OrdersTotal()-1; i >= 0; i--)
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
    {
        if (OrderSymbol() == Symbol() && OrderMagicNumber() == 1)
        {
            if (OrderType() == OP_BUY && Ask - OrderOpenPrice() > TrailingStop28*PipValue*Point)
            {
                if (OrderStopLoss() < Ask-(TrailingStop28+3)*PipValue*Point)
                OrderModify(OrderTicket(), OrderOpenPrice(), Ask-TrailingStop28*PipValue*Point, Ask+(NewTakeProfit28 + TrailingStop28)*PipValue*Point, OrderExpiration(), White);
            }
            if (OrderType() == OP_SELL && OrderOpenPrice() - Bid > TrailingStop28*PipValue*Point)
            {
                if (OrderStopLoss() > Bid+(TrailingStop28+3)*PipValue*Point)
                OrderModify(OrderTicket(), OrderOpenPrice(), Bid+TrailingStop28*PipValue*Point, Bid-(NewTakeProfit28 + TrailingStop28)*PipValue*Point, OrderExpiration(), White);
            }
        }
    }
    else
    Print("OrderSelect() error - ", ErrorDescription(GetLastError()));
    
}



int deinit()
{
    
}

